﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Collections.ObjectModel;

namespace WPF_xamGrid_DragDrop_Rows
{
    class GridDataCollection
    {
        private static ObservableCollection<GridData> coll;

        private static ObservableCollection<GridData> CreateCollection()
        {
            Random r = new Random();
            ObservableCollection<GridData> tcoll = new ObservableCollection<GridData>();
            String[] names = { "John", "Bill", "Mary", "Beth", "Carol", "Steve", "Tim" };

            for (int i = 1; i < 25; i++)
            {
                tcoll.Add(new GridData(i, names[r.Next(0, 7)], r.Next(1, 25)));
            }

            return tcoll;
        }

        public static ObservableCollection<GridData> GetData
        {
            get
            {
                if (coll == null)
                    coll = CreateCollection();

                return coll;
            }
        }

    }

    public class GridData : INotifyPropertyChanged
    {
        private int id;
        private string name;
        private int intvalue;

        public GridData(int id, string name, int intvalue)
        {
            ID = id;
            Name = name;
            IntValue = intvalue;

        }

        public int ID
        {
            get { return id; }
            set
            {
                if (id != value)
                {
                    id = value;
                    OnPropertyChanged("ID");
                }
            }
        }

        public string Name
        {
            get { return name; }
            set
            {
                if (name != value)
                {
                    name = value;
                    OnPropertyChanged("Name");
                }
            }
        }

        public int IntValue
        {
            get { return intvalue; }
            set
            {
                if (intvalue != value)
                {
                    intvalue = value;
                    OnPropertyChanged("IntValue");
                }
            }

        }


        public event PropertyChangedEventHandler PropertyChanged;
        protected virtual void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }
}
