﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Infragistics.DragDrop;
using Infragistics.Controls.Grids;
using System.Data;
using Infragistics.Controls.Grids.Primitives;
using Infragistics.Windows.Themes;
using WPF_xamGrid_DragDrop_Rows.Themes;

namespace WPF_xamGrid_DragDrop_Rows
{
    //=========================================================================
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        /// <summary>Objekt zur Verwaltung/Benutzung der Themen.</summary>
        private VerwaltungThemen Themen;

        ObservableCollection<GridData> tcoll = new ObservableCollection<GridData>();
        ObservableCollection<GridData> tmpSRCcoll = new ObservableCollection<GridData>();
        ObservableCollection<GridData> tmpTGTcoll = new ObservableCollection<GridData>();
        List<GridData> selGridData = new List<GridData>();

        //---------------------------------------------------------------------
        public MainWindow()
        {
            InitializeComponent();

            Loaded += new RoutedEventHandler(MainWindow_Loaded);
        }

        //---------------------------------------------------------------------
        void MainWindow_Loaded(object sender, RoutedEventArgs e)
        {
            // Themen-Verwaltung initialisieren.
            this.Themen = new VerwaltungThemen();
            // Unser Start-Thema laden.
            this.Themen.HauptThemaUmschalten("IG");


            //tcoll.Add(new GridData(100, "test", 99));
            xamGrid2.ItemsSource = tcoll;

            //Added fro when the second grid is empty
            DropTarget dropTarget = new DropTarget()
            {
                IsDropTarget = true,
                DropTargetMarkerBrush = new SolidColorBrush(Colors.LightGray)
            };           
            xamGrid2.SetValue(DragDropManager.DropTargetProperty, dropTarget);           
             
        }

        //---------------------------------------------------------------------
        private void xamGrid1_CellControlAttached(object sender, CellControlAttachedEventArgs e)
        {
            var cell = e.Cell;

            DragSource dragSource = new DragSource()
            {
                IsDraggable = true
            };
            dragSource.Drop += new EventHandler<DropEventArgs>(source_Drop);
            //dragSource.DragEnd += new EventHandler<DragDropEventArgs>(dragSource_DragEnd);
            //dragSource.DragStart += new EventHandler<DragDropStartEventArgs>(dragSource_DragStart);

            DropTarget dropTarget = new DropTarget()
            {
                IsDropTarget = true,
                DropTargetMarkerBrush = new SolidColorBrush(Colors.Yellow)
            };
            cell.Row.Control.SetValue(DragDropManager.DragSourceProperty, dragSource);
            cell.Row.Control.SetValue(DragDropManager.DropTargetProperty, dropTarget);
        }

        //---------------------------------------------------------------------
        private void xamGrid2_CellControlAttached(object sender, CellControlAttachedEventArgs e)
        {
            var cell = e.Cell;

            DragSource dragSource = new DragSource()
            {
                IsDraggable = true
            };
            dragSource.Drop += new EventHandler<DropEventArgs>(source_Drop);
           // dragSource.DragEnd += new EventHandler<DragDropEventArgs>(dragSource_DragEnd);
           // dragSource.DragStart += new EventHandler<DragDropStartEventArgs>(dragSource_DragStart);

            DropTarget dropTarget = new DropTarget()
            {
                IsDropTarget = true,
                DropTargetMarkerBrush = new SolidColorBrush(Colors.Yellow)
            };

            cell.Row.Control.SetValue(DragDropManager.DragSourceProperty, dragSource);
            cell.Row.Control.SetValue(DragDropManager.DropTargetProperty, dropTarget);
        }

        //---------------------------------------------------------------------
        void source_Drop(object sender, DropEventArgs e)
        {
            ObservableCollection<GridData> tmpcoll = new ObservableCollection<GridData>();
            XamGrid xamGridTGT = new XamGrid();
            XamGrid xamGridSRC = new XamGrid();
            GridData target = null;

            selGridData = new List<GridData>();   

            // Retrieving the Source.
            GridData source = (e.DragSource as CellsPanel).Row.Data as GridData;

            if ((e.DropTarget is CellsPanel) == true)
            {
               xamGridTGT = FindUpVisualTree<XamGrid>(e.DropTarget as CellsPanel);               
            }
            else if ((e.DropTarget is XamGrid) == true)
            {
               // Adding element to Target-XamGrid                            
               xamGridTGT = FindUpVisualTree<XamGrid>(e.DropTarget as XamGrid);               
            }           
            xamGridSRC = FindUpVisualTree<XamGrid>(e.DragSource as CellsPanel);          
           
            tmpTGTcoll = xamGridTGT.ItemsSource as ObservableCollection<GridData>;
            tmpSRCcoll = xamGridSRC.ItemsSource as ObservableCollection<GridData>;
            
            if (xamGridSRC.SelectionSettings.SelectedRows.Count > 1)
            {
                foreach (Row r in xamGridSRC.SelectionSettings.SelectedRows)
                {
                    if ((r as Row).RowType == RowType.DataRow)
                    {
                        int insrtIndex = tmpTGTcoll.IndexOf((r as Row).Data as GridData);
                        if (insrtIndex == -1)
                        {
                            selGridData.Add((r as Row).Data as GridData);
                            tmpTGTcoll.Add((r as Row).Data as GridData);
                        }
                    }
                }
                foreach (GridData data in selGridData)
                {
                    int removeIndex = tmpSRCcoll.IndexOf(data);
                    if (removeIndex >= 0)
                        tmpSRCcoll.RemoveAt(removeIndex);
                }
            }
            else
            {
                // Retrieving the Target  and add source to target   (CellsPanel or XamGrid if empty)
                if ((e.DropTarget is CellsPanel) == true)
                {
                    // Adding element to Target-XamGrid via CellsPanel   
                    target = (e.DropTarget as CellsPanel).Row.Data as GridData;

                    //xamGridTGT = FindUpVisualTree<XamGrid>(e.DropTarget as CellsPanel);
                    //tmpTGTcoll = xamGridTGT.ItemsSource as ObservableCollection<GridData>;
                    int insertIndex = tmpTGTcoll.IndexOf(target);
                    tmpTGTcoll.Insert(insertIndex, source);
                }
                else if ((e.DropTarget is XamGrid) == true)
                {
                    // Adding element to Target-XamGrid                            
                    //xamGridTGT = FindUpVisualTree<XamGrid>(e.DropTarget as XamGrid);
                    //tmpTGTcoll = xamGridTGT.ItemsSource as ObservableCollection<GridData>;
                    tmpTGTcoll.Add(source);
                }
                else return;

                // Removing element out of Source-XamGrid.
                //xamGridSRC = FindUpVisualTree<XamGrid>(e.DragSource as CellsPanel);
                int removeIndex = (xamGridSRC.ItemsSource as ObservableCollection<GridData>).IndexOf(source);
                (xamGridSRC.ItemsSource as ObservableCollection<GridData>).RemoveAt(removeIndex);
            }
        }

        //---------------------------------------------------------------------
        void dragSource_DragStart(object sender, DragDropStartEventArgs e)
        {
            // xamGrid1.SelectionSettings.CellClickAction = Infragistics.Controls.Grids.CellSelectionAction.SelectRow;                      
        }

        //---------------------------------------------------------------------
        void dragSource_DragEnd(object sender, DragDropEventArgs e)
        {
            // xamGrid1.SelectionSettings.CellClickAction = Infragistics.Controls.Grids.CellSelectionAction.SelectCell;
        }

        //---------------------------------------------------------------------
        public static T FindUpVisualTree<T>(DependencyObject initial) where T : DependencyObject
        {
            DependencyObject current = initial;

            while (current != null && current.GetType() != typeof(T))
            {
                current = VisualTreeHelper.GetParent(current);
            }
            return current as T;
        }

        //---------------------------------------------------------------------
        private void Hallo2_Click(object sender, RoutedEventArgs e)
        {
            WindowMyOwnMix WindowHallo2 = new WindowMyOwnMix();
            WindowHallo2.ShowDialog();
        }
    }
}
